<?php

$obj = [
  [
    ['r', 'r', 'r', 'r'],
    ['g', 'r', 'r', 'r'],
    ['g', 'g', 'r', 'r'],
    ['g', 'g', 'r', 'g'],
  ],[
    ['g', 'g', 'g', 'r'],
    ['g', 'g', 'g', 'g'],
    ['g', 'r', 'g', 'r'],
    ['g', 'r', 'g', 'g'],
  ],[
    ['g', 'r', 'r', 'g'],
    ['r', 'g', 'r', 'r'],
    ['r', 'g', 'r', 'g'],
    ['r', 'g', 'g', 'r'],
  ],[
    ['r', 'g', 'g', 'g'],
    ['r', 'r', 'g', 'r'],
    ['r', 'r', 'g', 'g'],
    ['r', 'r', 'g', 'r'],
  ],[
    ['r', 'r', 'r', 'g'],
  ]
];

$width = 1;
$offset = 5;
$res = 1024;
$res = 512;

$red = new ImagickDraw();
$red->setStrokeColor('rgb(255, 0, 0)');
$red->setFillColor('rgba(0, 0, 0, 0)');
$red->setStrokeWidth($width);
$red->setStrokeDashArray([$res / 16,  $res / 16]);

$green = new ImagickDraw();
$green->setStrokeColor('rgb(0, 255, 0)');
$green->setStrokeWidth($width);


foreach ($obj as $row => $rowItems) {
  foreach ($rowItems as $i => $v ) {
    foreach ($v as $s => $key) {
      $line = $red;
      if ($key == 'g') { $line = $green;}

      $x = $i * ($res + $offset) + ($offset/2);
      $y = $row * ($res + $offset) + ($offset/2);
      /*if ($i > 0) {
        $x += ($i+1) * $offset / 2;
      }
      if ($row > 0) {
        $y += ($row +1) * $offset / 2;
      }*/

      switch ($s) {
        case 0:
          $line->line($x, $y , $x + $res, $y);
          break;
        case 1:
          $line->line($x + $res,$y ,$x + $res ,$y +  $res);
          break;
        case 2:
          $line->line($x ,$y ,$x ,$y +  $res );
          break;
        case 3:
          $line->line($x ,$y +  $res,$x +  $res ,$y + $res );
          break;
      }
    }

  }
}


// for debugging, output to browser:
$image = new Imagick();
$image->newImage(4 * ($res + $offset), 5 * ($res+$offset), 'rgba(0,0,0,0)');
$image->setImageFormat("png");
$image->drawImage($red);
$image->drawImage($green);
header("Content-Type: image/png");
echo $image->getImageBlob();
