require "util"

data:extend(
  {
    {
      type = "simple-entity",
      name = "nilaus-chunk-border",
      icon = "__nilaus_s40__/graphics/icon/nilaus_logo.png",
      icon_size = 32,
      flags = {"placeable-neutral", "placeable-off-grid"},
      order = "x[nilaus-chunk-border]",
      render_layer = "selection-box",
      collision_box = {{-16, -16}, {16, 16}},
      collision_mask = {"layer-12"},
      pictures = {
        layers = {
          {
            filename = "__nilaus_s40__/graphics/entity/chunk-border.png",
            filenames = {"__nilaus_s40__/graphics/entity/chunk-border.png"},
            flags = {"not-compressed"},
            hr_version = {
              filename = "__nilaus_s40__/graphics/entity/chunk-border-hr.png",
              priority = "extra-high",
              width = 1034,
              height = 1034,
              shift = {-0.015, -0.015},
              line_length = 4,
              variation_count = 17
            },
            priority = "extra-high",
            width = 517,
            height = 517,
            shift = {-0.015, -0.015},
            line_length = 4,
            variation_count = 17,
            scale = 2
          }
        }
      }
    }
  }
)
