local shared = require "shared"

data:extend(
  {
    {
      type = "bool-setting",
      name = shared.settings.show_table,
      setting_type = "runtime-per-user",
      default_value = true,
      order = "a-a"
    },
    {
      type = "string-setting",
      name = shared.settings.table_caption,
      setting_type = "runtime-per-user",
      default_value = "TVC API",
      order = "a-b"
    },
    {
      type = "int-setting",
      name = shared.settings.chunk_cost,
      setting_type = "runtime-global",
      default_value = 1,
      minimum_value = 1,
      maximum_value = 100,
      order = "b-a"
    },
    {
      type = "bool-setting",
      name = shared.settings.disable_building,
      setting_type = "runtime-global",
      default_value = true,
      order = "b-b"
    },
    {
      type = "int-setting",
      name = shared.settings.member_spawn_ore,
      setting_type = "runtime-global",
      default_value = 100,
      order = "c-a"
    },
    {
      type = "int-setting",
      name = shared.settings.spawn_patch_size,
      setting_type = "runtime-global",
      default_value = 10,
      order = "c-b"
    }
  }
)
